package com.sun.corba.se.spi.activation;

import java.io.ObjectOutputStream;
import java.io.IOException;
import org.omg.CORBA.ORB;
import java.io.ObjectInputStream;
import com.sun.corba.se.spi.activation.InitialNameServicePackage.NameAlreadyBound;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.portable.InputStream;
import org.omg.CORBA.portable.RemarshalException;
import org.omg.CORBA.portable.ApplicationException;
import com.sun.corba.se.spi.activation.InitialNameServicePackage.NameAlreadyBoundHelper;
import org.omg.CORBA.MARSHAL;
import org.omg.CORBA.ObjectHelper;
import org.omg.CORBA.Object;
import org.omg.CORBA.portable.ObjectImpl;

public class _InitialNameServiceStub extends ObjectImpl implements InitialNameService
{
    private static String[] __ids;
    
    public _InitialNameServiceStub() {
    }
    
    public void bind(String s, org.omg.CORBA.Object object, boolean b) throws NameAlreadyBound {
        InputStream inputStream = null;
        try {
            OutputStream request = this._request("bind", true);
            request.write_string(s);
            ObjectHelper.write(request, object);
            request.write_boolean(b);
            inputStream = this._invoke(request);
            return;
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            String id = ex.getId();
            if (id.equals("IDL:activation/InitialNameService/NameAlreadyBound:1.0")) {
                throw NameAlreadyBoundHelper.read(inputStream);
            }
            throw new MARSHAL(id);
        }
        catch (RemarshalException ex2) {
            this.bind(s, object, b);
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public String[] _ids() {
        return (String[])(String[])_InitialNameServiceStub.__ids.clone();
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException {
        String utf = objectInputStream.readUTF();
        ORB init = ORB.init(null, null);
        try {
            this._set_delegate(((ObjectImpl)init.string_to_object(utf))._get_delegate());
        }
        finally {
            init.destroy();
        }
    }
    
    private void writeObject(ObjectOutputStream objectOutputStream) throws IOException {
        ORB init = ORB.init(null, null);
        try {
            objectOutputStream.writeUTF(init.object_to_string(this));
        }
        finally {
            init.destroy();
        }
    }
    
    static {
        _InitialNameServiceStub.__ids = new String[] { "IDL:activation/InitialNameService:1.0" };
    }
}
